/*   $OSSEC, read_syslog.c, v0.2, 2005/04/04, Daniel B. Cid$   */

/* Copyright (C) 2003,2004,2005 Daniel B. Cid <dcid@ossec.net>
 * All right reserved.
 *
 * This program is a free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation
 */

/* Read the syslog */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "headers/defs.h"
#include "headers/debug_op.h"
#include "headers/mq_op.h"
#include "logcollector.h"

extern collector logcollect;

/* Read syslog files/snort fast/apache files */

int read_syslog()
{
    int i=0,frst=0;
    
    char c;
    char str[OS_MAXSTR+1];

    str[0]='\0';
    
    while((c = fgetc(logcollect.fp)) != EOF)
    {
        
        if ((i >= OS_MAXSTR)||(c == '\n'))
        {
            if(i >= OS_MAXSTR)
            {
                merror("%s:  Log message overflow",ARGV0);
                str[OS_MAXSTR]='\0';
            }
            else
            {
                str[i]='\0';
            }
            
            #ifdef DEBUG
            verbose("%s: Read message: '%s'",ARGV0,str);
            #endif
            
            if(SendMSG(logcollect.queue,str,logcollect.file,
                       logcollect.group,logcollect.type) < 0)
            {
                merror("%s: Error sending message to queue",ARGV0);
                if((logcollect.queue = StartMQ(DEFAULTQPATH,WRITE)) < 0)
                {
                    merror("%s: Impossible to open queue",ARGV0);
                    sleep(60);
                    if((logcollect.queue = StartMQ(DEFAULTQPATH,WRITE)) < 0)
                    {
                        sleep(60);
                        if((logcollect.queue=StartMQ(DEFAULTQPATH,WRITE))<0)
                            ErrorExit("%s: Impossible to access queue %s",
                                    ARGV0,DEFAULTQPATH);
                    }
                }
            }
            memset(str,'\0',i);
            
            i = 0;
            frst = 1;
            
            continue;
        }

        str[i]=c;
        i++;
    }

   
	if((frst == 1)&&(i == 0))
		return (0);

	
    return(ftell(logcollect.fp));
}
